--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -6431,4 +9842,999 @@
 		qlt->qlt_bucketcnt[4] = cnt;
 		EL(qlt, "256k bucket o/l=%d\n", cnt);
 	}
+}
+
+/* ******************************************************************* */
+/* ****************** 27xx Dump Template Functions ******************* */
+/* ******************************************************************* */
+
+/*
+ * qlt_get_dmp_template
+ *	Get dump template from firmware module
+ *
+ * Input:
+ *	qlt:	qlt_state_t pointer.
+ *
+ * Returns:
+ *	qlt local function return status code.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static fct_status_t
+qlt_27xx_get_dmp_template(qlt_state_t *qlt)
+{
+	ddi_device_acc_attr_t dev_acc_attr;
+	dev_info_t *dip = qlt->dip;
+	uint_t ncookies;
+	size_t discard;
+	uint32_t word_count, cnt, *bp, *dp;
+
+	if (qlt->dmp_template_dma_handle != NULL) {
+		(void) ddi_dma_unbind_handle(qlt->dmp_template_dma_handle);
+		if (qlt->dmp_template_acc_handle != NULL) {
+			ddi_dma_mem_free(&qlt->dmp_template_acc_handle);
+		}
+		ddi_dma_free_handle(&qlt->dmp_template_dma_handle);
+	}
+
+	if ((word_count = tmplt2700_length01) == 0) {
+		EL(qlt, "No dump template, length=0\n");
+		return (QLT_FAILURE);
+	}
+
+	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
+	dev_acc_attr.devacc_attr_endian_flags = DDI_STRUCTURE_LE_ACC;
+	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;
+
+	if (ddi_dma_alloc_handle(dip, &qlt_queue_dma_attr,
+	    DDI_DMA_SLEEP, 0, &qlt->dmp_template_dma_handle) !=
+	    DDI_SUCCESS) {
+		EL(qlt, "Unable to allocate template handle");
+		return (QLT_FAILURE);
+	}
+
+	if (ddi_dma_mem_alloc(qlt->dmp_template_dma_handle,
+	    (word_count << 2), &dev_acc_attr, DDI_DMA_CONSISTENT,
+	    DDI_DMA_SLEEP, 0, &qlt->dmp_template_addr, &discard,
+	    &qlt->dmp_template_acc_handle) != DDI_SUCCESS) {
+		ddi_dma_free_handle(&qlt->dmp_template_dma_handle);
+		EL(qlt, "Unable to allocate template buffer");
+		return (QLT_FAILURE);
+	}
+
+	if (ddi_dma_addr_bind_handle(qlt->dmp_template_dma_handle, NULL,
+	    qlt->dmp_template_addr, (word_count << 2),
+	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, 0,
+	    &qlt->dmp_template_cookie, &ncookies) != DDI_SUCCESS) {
+		ddi_dma_mem_free(&qlt->dmp_template_acc_handle);
+		ddi_dma_free_handle(&qlt->dmp_template_dma_handle);
+		EL(qlt, "Unable to bind template handle");
+		return (QLT_FAILURE);
+	}
+
+	if (ncookies != 1) {
+		(void) ddi_dma_unbind_handle(qlt->dmp_template_dma_handle);
+		ddi_dma_mem_free(&qlt->dmp_template_acc_handle);
+		ddi_dma_free_handle(&qlt->dmp_template_dma_handle);
+		EL(qlt, "cookies (%d) > 1.\n", ncookies);
+		return (QLT_FAILURE);
+	}
+
+	/* Get big endian template. */
+	bp = (uint32_t *)qlt->dmp_template_addr;
+	dp = (uint32_t *)tmplt2700_code01;
+	for (cnt = 0; cnt < word_count; cnt++) {
+		ddi_put32(qlt->dmp_template_acc_handle, bp, *dp++);
+		if (cnt > 6) {
+			qlt_chg_endian((uint8_t *)bp, 4);
+		}
+		bp++;
+	}
+
+	return (QLT_SUCCESS);
+}
+
+static int
+qlt_27xx_dt_riob1(qlt_state_t *qlt, qlt_dt_riob1_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize;
+	uint32_t i, cnt;
+	uint8_t	 *bp = dbuff;
+	uint32_t addr = entry->addr;
+	uint32_t reg = entry->pci_offset;
+
+	cnt = CHAR_TO_SHORT(entry->reg_count_l, entry->reg_count_h);
+	esize = cnt * 4;		/* addr */
+	esize += cnt * entry->reg_size;	/* data */
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	REG_WR32(qlt, REG_IOBUS_BASE_ADDR, addr);
+	while (cnt--) {
+		*bp++ = LSB(LSW(addr));
+		*bp++ = MSB(LSW(addr));
+		*bp++ = LSB(MSW(addr));
+		*bp++ = MSB(MSW(addr));
+		for (i = 0; i < entry->reg_size; i++) {
+			*bp++ = REG_RD8(qlt, reg++);
+		}
+		addr++;
+	}
+
+	return (esize);
+}
+
+static void
+qlt_27xx_dt_wiob1(qlt_state_t *qlt, qlt_dt_wiob1_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	uint32_t reg = entry->pci_offset;
+
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	REG_WR32(qlt, REG_IOBUS_BASE_ADDR, entry->addr);
+	REG_WR32(qlt, reg, entry->data);
+}
+
+static int
+qlt_27xx_dt_riob2(qlt_state_t *qlt, qlt_dt_riob2_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize;
+	uint32_t i, cnt;
+	uint8_t	 *bp = dbuff;
+	uint32_t reg = entry->pci_offset;
+	uint32_t addr = entry->addr;
+
+	cnt = CHAR_TO_SHORT(entry->reg_count_l, entry->reg_count_h);
+	esize = cnt * 4;		/* addr */
+	esize += cnt * entry->reg_size;	/* data */
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	REG_WR32(qlt, REG_IOBUS_BASE_ADDR, addr);
+	REG_WR32(qlt, entry->bank_sel_offset, entry->reg_bank);
+	while (cnt--) {
+		*bp++ = LSB(LSW(addr));
+		*bp++ = MSB(LSW(addr));
+		*bp++ = LSB(MSW(addr));
+		*bp++ = MSB(MSW(addr));
+		for (i = 0; i < entry->reg_size; i++) {
+			*bp++ = REG_RD8(qlt, reg++);
+		}
+		addr++;
+	}
+
+	return (esize);
+}
+
+static void
+qlt_27xx_dt_wiob2(qlt_state_t *qlt, qlt_dt_wiob2_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	uint16_t data;
+	uint32_t reg = entry->pci_offset;
+
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	data = CHAR_TO_SHORT(entry->data_l, entry->data_h);
+
+	REG_WR32(qlt, REG_IOBUS_BASE_ADDR, entry->addr);
+	REG_WR32(qlt, entry->bank_sel_offset, entry->reg_bank);
+	REG_WR16(qlt, reg, data);
+}
+
+static int
+qlt_27xx_dt_rpci(qlt_state_t *qlt, qlt_dt_rpci_t *entry, uint8_t *dbuff,
+    uint8_t *dbuff_end)
+{
+	int esize;
+	uint32_t i;
+	uint8_t	*bp = dbuff;
+	uint32_t reg = entry->addr;
+
+	esize = 4;	/* addr */
+	esize += 4;	/* data */
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	*bp++ = LSB(LSW(entry->addr));
+	*bp++ = MSB(LSW(entry->addr));
+	*bp++ = LSB(MSW(entry->addr));
+	*bp++ = MSB(MSW(entry->addr));
+	for (i = 0; i < 4; i++) {
+		*bp++ = REG_RD8(qlt, reg++);
+	}
+
+	return (esize);
+}
+
+static void
+qlt_27xx_dt_wpci(qlt_state_t *qlt, qlt_dt_wpci_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	uint32_t reg = entry->addr;
+
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	REG_WR32(qlt, reg, entry->data);
+}
+
+static int
+qlt_27xx_dt_rram(qlt_state_t *qlt, qlt_dt_rram_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize, rval;
+	uint32_t start = entry->start_addr;
+	uint32_t end = entry->end_addr;
+
+	if (entry->ram_area == 2) {
+		end = qlt->fw_ext_memory_end;
+	} else if (entry->ram_area == 3) {
+		start = qlt->fw_shared_ram_start;
+		end = qlt->fw_shared_ram_end;
+	} else if (entry->ram_area == 4) {
+		start = qlt->fw_ddr_ram_start;
+		end = qlt->fw_ddr_ram_end;
+	} else if (entry->ram_area != 1) {
+		EL(qlt, "skipped, unknown RAM_AREA %d\n", entry->ram_area);
+		start = 0;
+		end = 0;
+	}
+	esize = end > start ? end - start : 0;
+	if (esize) {
+		esize = (esize + 1) * 4;
+	}
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize == 0 || esize + dbuff >= dbuff_end) {
+		if (esize != 0) {
+			EL(qlt, "skipped, no buffer space, needed=%xh\n",
+			    esize);
+		} else {
+			EL(qlt, "skipped, no ram_area=%xh, start=%xh "
+			    "end=%xh\n", entry->ram_area, start, end);
+		}
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+	entry->end_addr = end;
+	entry->start_addr = start;
+
+	if ((rval = qlt_27xx_dump_ram(qlt, MBC_DUMP_RAM_EXTENDED,
+	    start, esize / 4, dbuff)) != QLT_SUCCESS) {
+		EL(qlt, "dump_ram failed, rval=%xh, addr=%xh, len=%xh, "
+		    "esize=0\n", rval, start, esize / 4);
+		return (0);
+	}
+
+	return (esize);
+}
+
+static int
+qlt_27xx_dt_gque(qlt_state_t *qlt, qlt_dt_gque_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize;
+	uint32_t cnt, q_cnt, e_cnt, i;
+	uint8_t	*bp = dbuff, *dp;
+
+	if (entry->queue_type == 1) {
+		e_cnt = qlt->qlt_queue_cnt;
+		esize = e_cnt * 2;	/* queue number */
+		esize += e_cnt * 2;	/* queue entries */
+
+		/* queue size */
+		esize += REQUEST_QUEUE_ENTRIES * IOCB_SIZE;
+		for (q_cnt = 1; q_cnt < qlt->qlt_queue_cnt; q_cnt++) {
+			esize += REQUEST_QUEUE_MQ_ENTRIES * IOCB_SIZE;
+		}
+
+		if (dbuff == NULL) {
+			return (esize);
+		}
+		if (esize + dbuff >= dbuff_end) {
+			EL(qlt, "skipped, no buffer space, needed=%xh\n",
+			    esize);
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+			return (0);
+		}
+		entry->num_queues = e_cnt;
+
+		for (q_cnt = 0; q_cnt < entry->num_queues; q_cnt++) {
+			e_cnt = q_cnt == 0 ?
+			    REQUEST_QUEUE_ENTRIES : REQUEST_QUEUE_MQ_ENTRIES;
+			dp = (uint8_t *)qlt->mq_req[q_cnt].mq_ptr;
+			*bp++ = LSB(q_cnt);
+			*bp++ = MSB(q_cnt);
+			*bp++ = LSB(e_cnt);
+			*bp++ = MSB(e_cnt);
+			for (cnt = 0; cnt < e_cnt; cnt++) {
+				for (i = 0; i < IOCB_SIZE; i++) {
+					*bp++ = *dp++;
+				}
+			}
+		}
+	} else if (entry->queue_type == 2) {
+
+		e_cnt = qlt->qlt_queue_cnt;
+		esize = e_cnt * 2;	/* queue number */
+		esize += e_cnt * 2;	/* queue entries */
+
+		/* queue size */
+		esize += RESPONSE_QUEUE_ENTRIES * IOCB_SIZE;
+		for (q_cnt = 1; q_cnt < qlt->qlt_queue_cnt; q_cnt++) {
+			esize += RESPONSE_QUEUE_MQ_ENTRIES * IOCB_SIZE;
+		}
+
+		if (dbuff == NULL) {
+			return (esize);
+		}
+		if (esize + dbuff >= dbuff_end) {
+			EL(qlt, "skipped2, no buffer space, needed=%xh\n",
+			    esize);
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+			return (0);
+		}
+		entry->num_queues = e_cnt;
+
+		for (q_cnt = 0; q_cnt < entry->num_queues; q_cnt++) {
+			e_cnt = q_cnt == 0 ?
+			    RESPONSE_QUEUE_ENTRIES : RESPONSE_QUEUE_MQ_ENTRIES;
+			dp = (uint8_t *)qlt->mq_resp[q_cnt].mq_ptr;
+			*bp++ = LSB(q_cnt);
+			*bp++ = MSB(q_cnt);
+			*bp++ = LSB(e_cnt);
+			*bp++ = MSB(e_cnt);
+			for (cnt = 0; cnt < e_cnt; cnt++) {
+				for (i = 0; i < IOCB_SIZE; i++) {
+					*bp++ = *dp++;
+				}
+			}
+		}
+	} else if (entry->queue_type == 3) {
+		e_cnt = 1;
+		esize = e_cnt * 2;	/* queue number */
+		esize += e_cnt * 2;	/* queue entries */
+
+		/* queue size */
+		esize += RESPONSE_QUEUE_ENTRIES * IOCB_SIZE;
+
+		if (dbuff == NULL) {
+			return (esize);
+		}
+		if (esize + dbuff >= dbuff_end) {
+			EL(qlt, "skipped2, no buffer space, needed=%xh\n",
+			    esize);
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+			return (0);
+		}
+		entry->num_queues = e_cnt;
+
+		for (q_cnt = 0; q_cnt < entry->num_queues; q_cnt++) {
+			e_cnt = ATIO_QUEUE_ENTRIES;
+			dp = (uint8_t *)qlt->atio_ptr;
+			*bp++ = LSB(q_cnt);
+			*bp++ = MSB(q_cnt);
+			*bp++ = LSB(e_cnt);
+			*bp++ = MSB(e_cnt);
+			for (cnt = 0; cnt < e_cnt; cnt++) {
+				for (i = 0; i < IOCB_SIZE; i++) {
+					*bp++ = *dp++;
+				}
+			}
+		}
+	} else {
+		EL(qlt, "skipped, unknown queue_type %d, esize=0\n",
+		    entry->queue_type);
+		if (dbuff != NULL) {
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+		}
+		return (0);
+	}
+
+	return (esize);
+}
+
+/*ARGSUSED*/
+static int
+qlt_27xx_dt_gfce(qlt_state_t *qlt, qlt_dt_gfce_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	if (dbuff != NULL) {
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+	}
+
+	return (0);
+}
+
+static void
+qlt_27xx_dt_prisc(qlt_state_t *qlt, qlt_dt_prisc_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	clock_t	timer;
+
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	/* Pause RISC. */
+	if ((REG_RD32(qlt, REG_RISC_STATUS) & BIT_8) == 0) {
+		REG_WR32(qlt, REG_HCCR, 0x30000000);
+		for (timer = 30000;
+		    (REG_RD32(qlt, REG_RISC_STATUS) & BIT_8) == 0;
+		    timer--) {
+			if (timer) {
+				drv_usecwait(100);
+				if (timer % 10000 == 0) {
+					EL(qlt, "risc pause %d\n", timer);
+				}
+			} else {
+				EL(qlt, "risc pause timeout\n");
+				break;
+			}
+		}
+	}
+}
+
+static void
+qlt_27xx_dt_rrisc(qlt_state_t *qlt, qlt_dt_rrisc_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	clock_t	timer;
+	uint16_t rom_status;
+
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	/* Shutdown DMA. */
+	REG_WR32(qlt, REG_CTRL_STATUS, DMA_SHUTDOWN_CTRL);
+
+	/* Wait for DMA to stop. */
+	for (timer = 0; timer < 30000; timer++) {
+		if (!(REG_RD32(qlt, REG_CTRL_STATUS) & DMA_ACTIVE_STATUS)) {
+			break;
+		}
+		drv_usecwait(100);
+	}
+
+	/* Reset the chip. */
+	REG_WR32(qlt, REG_CTRL_STATUS, CHIP_SOFT_RESET);
+	drv_usecwait(200);
+
+	/* Wait for RISC to recover from reset. */
+	for (timer = 30000; timer; timer--) {
+		rom_status = REG_RD16(qlt, REG_MBOX0);
+		if ((rom_status & MBS_ROM_STATUS_MASK) != MBS_ROM_BUSY) {
+			break;
+		}
+		drv_usecwait(100);
+	}
+
+	/* Wait for reset to finish. */
+	for (timer = 30000; timer; timer--) {
+		if (!(REG_RD32(qlt, REG_CTRL_STATUS) & CHIP_SOFT_RESET)) {
+			break;
+		}
+		drv_usecwait(100);
+	}
+
+	/* XXX: Disable Interrupts (Probably not needed) */
+	REG_WR32(qlt, REG_INTR_CTRL, 0);
+
+	qlt->qlt_intr_enabled = 0;
+}
+
+static void
+qlt_27xx_dt_dint(qlt_state_t *qlt, qlt_dt_dint_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	PCICFG_WR32(qlt, entry->pci_offset, entry->data);
+}
+
+/*ARGSUSED*/
+static int
+qlt_27xx_dt_ghbd(qlt_state_t *qlt, qlt_dt_ghbd_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	if (dbuff != NULL) {
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+	}
+
+	return (0);
+}
+
+/*ARGSUSED*/
+static int
+qlt_27xx_dt_scra(qlt_state_t *qlt, qlt_dt_scra_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	if (dbuff != NULL) {
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+	}
+
+	return (0);
+}
+
+static int
+qlt_27xx_dt_rrreg(qlt_state_t *qlt, qlt_dt_rrreg_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize;
+	uint32_t i;
+	uint8_t	*bp = dbuff;
+	uint32_t addr = entry->addr;
+	uint32_t cnt = entry->count;
+
+	esize = cnt * 4;	/* addr */
+	esize += cnt * 4;	/* data */
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	REG_WR32(qlt, REG_IOBUS_BASE_ADDR, 0x40);
+	while (cnt--) {
+		REG_WR32(qlt, 0xc0, addr | 0x80000000);
+		*bp++ = LSB(LSW(addr));
+		*bp++ = MSB(LSW(addr));
+		*bp++ = LSB(MSW(addr));
+		*bp++ = MSB(MSW(addr));
+		for (i = 0; i < 4; i++) {
+			*bp++ = REG_RD8(qlt, i);
+		}
+		addr += 4;
+	}
+
+	return (esize);
+}
+
+static void
+qlt_27xx_dt_wrreg(qlt_state_t *qlt, qlt_dt_wrreg_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	if (dbuff == NULL) {
+		return;
+	}
+	if (dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=0\n");
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return;
+	}
+
+	REG_WR32(qlt, REG_IOBUS_BASE_ADDR, 0x40);
+	REG_WR32(qlt, 0xc4, entry->data);
+	REG_WR32(qlt, 0xc0, entry->addr);
+}
+
+static int
+qlt_27xx_dt_rrram(qlt_state_t *qlt, qlt_dt_rrram_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int rval, esize;
+
+	esize = entry->count * 4;	/* data */
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	if ((rval = qlt_27xx_dump_ram(qlt, MBC_MPI_RAM, entry->addr,
+	    entry->count, dbuff)) != QLT_SUCCESS) {
+		EL(qlt, "dump_ram failed, rval=%xh, addr=%xh, len=%xh, "
+		    "esize=0\n", rval, entry->addr, entry->count);
+		return (0);
+	}
+
+	return (esize);
+}
+
+static int
+qlt_27xx_dt_rpcic(qlt_state_t *qlt, qlt_dt_rpcic_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize;
+	uint32_t i;
+	uint8_t	*bp = dbuff;
+	uint32_t addr = entry->addr;
+	uint32_t cnt = entry->count;
+
+	esize = cnt * 4;	/* addr */
+	esize += cnt * 4;	/* data */
+
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	while (cnt--) {
+		*bp++ = LSB(LSW(addr));
+		*bp++ = MSB(LSW(addr));
+		*bp++ = LSB(MSW(addr));
+		*bp++ = MSB(MSW(addr));
+		for (i = 0; i < 4; i++) {
+			*bp++ = PCICFG_RD8(qlt, addr++);
+		}
+	}
+
+	return (esize);
+}
+
+/*ARGSUSED*/
+static int
+qlt_27xx_dt_gques(qlt_state_t *qlt, qlt_dt_gques_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	if (entry->queue_type == 1) {
+		EL(qlt, "skipped, no request queue shadowing, esize=0\n");
+		if (dbuff != NULL) {
+			entry->num_queues = 0;
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+		}
+		return (0);
+	} else if (entry->queue_type == 2) {
+		EL(qlt, "skipped, no response queue shadowing, esize=0\n");
+		if (dbuff != NULL) {
+			entry->num_queues = 0;
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+		}
+		return (0);
+	} else if (entry->queue_type == 3) {
+		EL(qlt, "skipped, no ATIO queue, esize=0\n");
+		if (dbuff != NULL) {
+			entry->num_queues = 0;
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+		}
+		return (0);
+	} else {
+		EL(qlt, "skipped, unknown queue_type %d, esize=0\n",
+		    entry->queue_type);
+		if (dbuff != NULL) {
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+		}
+		return (0);
+	}
+}
+
+static int
+qlt_27xx_dt_wdmp(qlt_state_t *qlt, qlt_dt_wdmp_t *entry,
+    uint8_t *dbuff, uint8_t *dbuff_end)
+{
+	int esize;
+	uint8_t *bp = dbuff;
+	uint32_t data, cnt = entry->length, *dp = entry->data;
+
+	esize = cnt;
+	if (dbuff == NULL) {
+		return (esize);
+	}
+	if (esize + dbuff >= dbuff_end) {
+		EL(qlt, "skipped, no buffer space, needed=%xh\n", esize);
+		entry->h.driver_flags = (uint8_t)
+		    (entry->h.driver_flags | SKIPPED_FLAG);
+		return (0);
+	}
+
+	while (cnt--) {
+		data = *dp++;
+		*bp++ = LSB(LSW(data));
+		*bp++ = MSB(LSW(data));
+		*bp++ = LSB(MSW(data));
+		*bp++ = MSB(MSW(data));
+	}
+
+	return (esize);
+}
+
+/*
+ * qlt_27xx_dump_ram
+ *	Dumps RAM.
+ *	Risc interrupts must be disabled when this routine is called.
+ *
+ * Input:
+ *	pi:		port info pointer.
+ *	cmd:		MBC_DUMP_RAM_EXTENDED/MBC_MPI_RAM.
+ *	risc_address:	RISC code start address.
+ *	len:		Number of words.
+ *	bp:		buffer pointer.
+ *
+ * Returns:
+ *	qlt local function return status code.
+ *
+ * Context:
+ *	Interrupt or Kernel context, no mailbox commands allowed.
+ */
+/*ARGSUSED*/
+static int
+qlt_27xx_dump_ram(qlt_state_t *qlt, uint16_t cmd, uint32_t risc_address,
+    uint32_t len, uint8_t *bp)
+{
+	uint8_t *dp;
+	uint32_t words_to_read, endaddr;
+	uint32_t i;
+	int rval = QLT_SUCCESS;
+
+	endaddr = risc_address + len;
+	words_to_read = 0;
+	while (risc_address < endaddr) {
+		words_to_read = MBOX_DMA_MEM_SIZE >> 2;
+		if ((words_to_read + risc_address) > endaddr) {
+			words_to_read = endaddr - risc_address;
+		}
+
+		if (cmd == MBC_DUMP_RAM_EXTENDED) {
+			rval = qlt_read_risc_ram(qlt, risc_address,
+			    words_to_read);
+		} else {
+			rval = qlt_mbx_mpi_ram(qlt, risc_address,
+			    words_to_read, 0);
+		}
+
+		if (rval != QLT_SUCCESS) {
+			EL(qlt, "Error reading risc ram = %xh len = %x\n",
+			    risc_address, words_to_read);
+			return (rval);
+		}
+
+		dp = (uint8_t *)(qlt->queue_mem_ptr + MBOX_DMA_MEM_OFFSET);
+		for (i = 0; i < (words_to_read * 4); i++) {
+			*bp++ = *dp++;
+		}
+		risc_address += words_to_read;
+	}
+
+	return (rval);
+}
+
+static uint32_t
+qlt_27xx_dmp_parse_template(qlt_state_t *qlt, qlt_dt_hdr_t *template_hdr,
+    uint8_t *dump_buff, uint32_t buff_size)
+{
+	int e_cnt, esize, num_of_entries;
+	uint32_t bsize;
+	time_t time;
+	uint8_t *dbuff, *dbuff_end;
+	qlt_dt_entry_t *entry;
+	int sane_end = 0;
+
+	dbuff = dump_buff;	/* dbuff = NULL	size determination. */
+	dbuff_end = dump_buff + buff_size;
+
+	if (template_hdr->type != DT_THDR) {
+		EL(qlt, "Template header not found\n");
+		return (0);
+	}
+	if (dbuff != NULL) {
+		(void) drv_getparm(TIME, &time);
+		template_hdr->driver_timestamp = LSD(time);
+	}
+
+	num_of_entries = template_hdr->num_of_entries;
+	entry = (qlt_dt_entry_t *)((caddr_t)template_hdr +
+	    template_hdr->first_entry_offset);
+
+	bsize = template_hdr->size_of_template;
+	for (e_cnt = 0; e_cnt < num_of_entries; e_cnt++) {
+		/*
+		 * Decode the entry type and process it accordingly
+		 */
+		esize = 0;
+		switch (entry->h.type) {
+		case DT_NOP:
+			if (dbuff != NULL) {
+				entry->h.driver_flags = (uint8_t)
+				    (entry->h.driver_flags | SKIPPED_FLAG);
+			}
+			break;
+		case DT_TEND:
+			if (dbuff != NULL) {
+				entry->h.driver_flags = (uint8_t)
+				    (entry->h.driver_flags | SKIPPED_FLAG);
+			}
+			sane_end++;
+			break;
+		case DT_RIOB1:
+			esize = qlt_27xx_dt_riob1(qlt, (qlt_dt_riob1_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_WIOB1:
+			qlt_27xx_dt_wiob1(qlt, (qlt_dt_wiob1_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RIOB2:
+			esize = qlt_27xx_dt_riob2(qlt, (qlt_dt_riob2_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_WIOB2:
+			qlt_27xx_dt_wiob2(qlt, (qlt_dt_wiob2_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RPCI:
+			esize = qlt_27xx_dt_rpci(qlt, (qlt_dt_rpci_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_WPCI:
+			qlt_27xx_dt_wpci(qlt, (qlt_dt_wpci_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RRAM:
+			esize = qlt_27xx_dt_rram(qlt, (qlt_dt_rram_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_GQUE:
+			esize = qlt_27xx_dt_gque(qlt, (qlt_dt_gque_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_GFCE:
+			esize = qlt_27xx_dt_gfce(qlt, (qlt_dt_gfce_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_PRISC:
+			qlt_27xx_dt_prisc(qlt, (qlt_dt_prisc_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RRISC:
+			qlt_27xx_dt_rrisc(qlt, (qlt_dt_rrisc_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_DINT:
+			qlt_27xx_dt_dint(qlt, (qlt_dt_dint_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_GHBD:
+			esize = qlt_27xx_dt_ghbd(qlt, (qlt_dt_ghbd_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_SCRA:
+			esize = qlt_27xx_dt_scra(qlt, (qlt_dt_scra_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RRREG:
+			esize = qlt_27xx_dt_rrreg(qlt, (qlt_dt_rrreg_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_WRREG:
+			qlt_27xx_dt_wrreg(qlt, (qlt_dt_wrreg_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RRRAM:
+			esize = qlt_27xx_dt_rrram(qlt, (qlt_dt_rrram_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_RPCIC:
+			esize = qlt_27xx_dt_rpcic(qlt, (qlt_dt_rpcic_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_GQUES:
+			esize = qlt_27xx_dt_gques(qlt, (qlt_dt_gques_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		case DT_WDMP:
+			esize = qlt_27xx_dt_wdmp(qlt, (qlt_dt_wdmp_t *)entry,
+			    dbuff, dbuff_end);
+			break;
+		default:
+			entry->h.driver_flags = (uint8_t)
+			    (entry->h.driver_flags | SKIPPED_FLAG);
+			EL(qlt, "Entry ID=%d, type=%d unknown\n", e_cnt,
+			    entry->h.type);
+			break;
+		}
+		if (dbuff != NULL && esize) {
+			dbuff += esize;
+		}
+		bsize += esize;
+		/* next entry in the template */
+		entry = (qlt_dt_entry_t *)((caddr_t)entry + entry->h.size);
+	}
+	if (sane_end > 1) {
+		EL(qlt, "Template configuration error. Check Template\n");
+	}
+
+	return (bsize);
 }
